include "console.iol"
include "common.iol"

inputPort Server {
  Location: "socket://localhost:8000"
  Protocol: sodep
  Interfaces: SumServerInterface
}

cset {
  user_session: LoginType.userID SumType.userID
}

execution{ concurrent }

main
{
  login( req );
  csets.user_session = req.userID;
  service_instance = new;
  println@Console( csets.user_session + " is logged in. Handling instance: " + service_instance )();
  add( x );
  println@Console( csets.user_session + " added " + x.addend + ". Handling instance: " + service_instance )();
  add( y );
  println@Console( csets.user_session + " added " + y.addend + ". Handling instance: " + service_instance )();
  sum( sumReq )( sumRes ){
    println@Console( csets.user_session + " requested the sum. Handling instance: " + service_instance )();
    sumRes = x.addend + y.addend
  }
}